#include <bits/stdc++.h>
using namespace std;
int n,a[200005],q,l,r,ps[200005];
bool solve(int x,int y){
    bool rez=true;
    int br=0;
    if((y-x+1)==1 or (y-x+1)==2)return true;

    for(int i=x+1;i<=y;i++){
        if(a[i]<a[i-1]){
            if(i==x+1){
                if(a[i+1]>=a[i] or a[i+1]>=a[i-1]){
                    br++;
                }
                else{
                    rez=false;
                }
            }
            else if(i==y){
                br++;
            }
            else if((i-2)>=x and a[i-2]<=a[i]){
                br++;
            }
            else if((i+1)<=y and a[i+1]>=a[i-1]){
                br++;
            }
            else{
                rez=false;
                break;
            }
        }
    }
    if(br>1)rez=false;

    return rez;

}
int main(){
    scanf("%d", &n);
    for(int i=1;i<=n;i++){
        scanf("%d", &a[i]);
    }
    int tren=0;
//    for(int i=1;i<=n;i++){
//        if(a[i]<a[i-1])tren=1;
//        else           tren=0;
//        ps[i]=ps[i-1]+tren;
//    }
    ps[1]=0;
    for(int i=2;i<=n;i++){
        tren=0;
        if(a[i]<a[i-1]){
            if(i==2){
                if(a[i+1]>=a[i] or a[i+1]>=a[i-1]){
                    tren=1;
                }
                else{
                    tren=7;
                }
            }
            else if(i==n){
                tren=1;
            }
            else if((i-2)>=1 and a[i-2]<=a[i]){
                tren=1;
            }
            else if((i+1)<=n and a[i+1]>=a[i-1]){
                tren=1;
            }
            else{
                tren=7;
                break;
            }
        }
        ps[i]=ps[i-1]+tren;

    }
    scanf("%d", &q);
    while(q--){
        scanf("%d%d", &l, &r);
//        if(solve(l,r)){
//            cout<<"DA"<<endl;
//        }
//        else{
//            cout<<"NE"<<endl;
//        }
        if((r-l)==1 or (r-l)==0){
            cout<<"DA"<<endl;
        }
        else{
            if((ps[r]-ps[l-1])>1){
                cout<<"NE"<<endl;
            }
            else{
                cout<<"DA"<<endl;
            }
        }
    }


return 0;}